<?php
// $Id: pagestyle.admin.inc,v 1.1.2.3 2009/10/01 01:42:41 christianzwahlen Exp $

/**
 * @file
 * Provides the Page Style administrative interface.
 */

/**
 * Implementation of hook_help().
 */
function pagestyle_help($path, $arg) {
  $path_pagestyle = base_path() . drupal_get_path('module', 'pagestyle');
  $pagestyle_increment = variable_get('pagestyle_increment', 10);
  $link_wcag = l('Web Content Accessibility Guidelines', 'http://www.w3.org/TR/WCAG/', array('attributes' => array('title' => 'Web Content Accessibility Guidelines')));
  $link_bitv= l('bundesrecht.juris.de', 'http://bundesrecht.juris.de/bitv/anlage_8.html', array('attributes' => array('title' => 'bundesrecht.juris.de')));
  $link_ff = l('www.mozilla.com/en-US/firefox/', 'http://www.mozilla.com/en-US/firefox', array('attributes' => array('title' => 'Mozilla Firefox')));
  $link_ps = l(t('Page Style') .' '. t('Home page'), 'http://zwahlendesign.ch/en/pagestyle', array('attributes' => array('title' => t('Page Style') .' '. t('Home page'))));
  $abbr_php = '<abbr lang="en" xml:lang="en" title="PHP: Hypertext Preprocessor">PHP</abbr>';
  $abbr_mysql = '<abbr title="MySQL">MySQL</abbr>';
  $abbr_xhtml = '<abbr lang="en" xml:lang="en" title="Extensible Hypertext Markup Language">XHTML</abbr>';
  $abbr_css = '<abbr lang="en" xml:lang="en" title="Cascading Style Sheets">CSS</abbr>';
  $abbr_wcag = '<abbr lang="en xml:lang="en" title="Web Content Accessibility Guidelines">WCAG</abbr>';
  $abbr_bitv = '<abbr lang="de" xml:lang="de" title="Barrierefreie Informationstechnik-Verordnung">BITV</abbr>';
  $abbr_png = '<abbr lang="en" xml:lang="en" title="Portable Network Graphics">PNG</abbr>';
  $abbr_gif = '<abbr lang="en" xml:lang="en" title="Graphic Interchange Format">GIF</abbr>';
  switch ($path) {
    case 'admin/help#pagestyle':
      $output = '<p><img src="'. $path_pagestyle .'/images/pagestyle_list.png" alt="'. t('Screenshot of block:') .' '. t('Select menu') .'." class="float_right" />'. t('This module display a style changer on the page and in the browser menue for a better web accessibility.') .'</p>'."\n";
      $output .= '<h3>'. t('Advantages') .'</h3>'."\n";
      $output .= '<ol>'."\n";
      $output .= '<li><strong>'. t('No building of extra themes required!') .' '. t('Black') .'/'. t('White') .', '. t('White') .'/'. t('Black') .' '. t('and') .' '.  t('Yellow') .'/'. t('Blue') .'.</strong></li>'."\n";
      $output .= '<li><strong>'. t('Style changer in the browser available.') .'</strong></li>'."\n";
      $output .= '<li><strong>'. t('One click function. No tutorial required.') .'</strong></li>'."\n";
      $output .= '<li>'. t('Same handling in any browser (shortcuts).') .'</li>'."\n";
      $output .= '<li>'. t('Adjustable.') .'</li>'."\n";
      $output .= '<li>'. t('Select menu availabe.') .'</li>'."\n";
      $output .= '<li>'. t('Display current page style.') .'</li>'."\n";
      $output .= '<li>'. t('Browser independent.') .'</li>'."\n";
      $output .= '</ol>'."\n";
      $output .= '<h3>'. t('Requirements') .'</h3>'."\n";
      $output .= '<ol>'."\n";
      $output .= '<li>'. t('Drupal Module:') .' '. l(t('jQuery plugins'), 'http://drupal.org/project/jquery_plugin') .'.</li>'."\n";
      $output .= '</ol>'."\n";
      $output .= '<h3>'. t('Features') .'</h3>'."\n";
      $output .= '<p>'. t('The module is a !abbr_php module and use JavaScript and Cookies if supported,  but no !abbr_mysql. Cookies are required, for saving the style durable and in old browsers.', array('!abbr_php' =>  $abbr_php, '!abbr_mysql' =>  $abbr_mysql)) .'</p>'."\n";
      $output .= '<ul>'."\n";
      $output .= '<li>'. t('!abbr_wcag and !abbr_bitv conform. More Information on: !link_wcag and !link_bitv.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv, '!link_wcag' => $link_wcag, '!link_bitv' => $link_bitv)) .' '. t('Keep the conditions:') .' '."\n";
      $output .= '  <ol>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 1.1: Alt text in the images.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 3.1: Standard links with text and not images.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 6.3: No JavaScript rquired.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 11.1: Open and standard code.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  <li>'. t('!abbr_wcag/!abbr_bitv 13.6: Links in a list.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</li>'."\n";
      $output .= '  </ol>'."\n";
      $output .= '</li>'."\n";
      $output .= '<li>'. t('No JavaScript required. jQuery suppport.') .'</li>'."\n";
      $output .= '<li>'. t('No !abbr_css required.', array('!abbr_css' => $abbr_css)) .'</li>'."\n";
      $output .= '<li>'. t('Style display settings') .'.</li>'."\n";
      $output .= '<li>'. t('Page Style Normal') .'.</li>'."\n";
      $output .= '<li>'. t('Caching mode: "Normal" and "Aggressive" compatible.') .'</li>'."\n";
      $output .= '  <li>'. t('Block type') ."\n";
      $output .= '    <ol>'."\n";
      $output .= '    <li><a href="#ps_text" title="'. t('Block') .': '. t('Text links') .'.">'. t('Text links') .'</a> [1].</li>'."\n";
      $output .= '    <li><a href="#ps_images" title="'. t('Block') .': '. t('Image links') .'.">'. t('Image links') .'</a> [2].</li>'."\n";
      $output .= '    <li><a href="#ps_select" title="'. t('Block') .': '. t('Select menu') .'.">'. t('Select menu') .'.</a></li>'."\n";
      $output .= '    </ol>'."\n";
      $output .= '  </li>'."\n";
      $output .= '<li>'. t('Uniform markin of menu, based on the open source browser Firefox 2.0 (!link_ff).', array('!link_ff' => $link_ff)) .'</li>'."\n";
      $output .= '<li>'. t('Themable. See: pagestyle-text.tpl.php, pagestyle-image.tpl.php or pagestyle-form.tpl.php.') .'</li>'."\n";
      $output .= '<li>'. t('Tested themes: Bluemarine, Garland.') .'</li>'."\n";
      $output .= '</ul>'."\n";
      $output .= '<hr/>'."\n";
      $output .= '<h3>'. t('Global settings') .'</h3>'."\n";
      $output .= '<h4>'. t('Block type') .'</h4>'."\n";
      $output .= '<dl>'."\n";
      $output .= '  <dt id="ps_text">'. t('Text links') .'</dt>'."\n";
      $output .= '  <dd><img src="'. $path_pagestyle .'/images/pagestyle_list.png" alt="'. t('Screenshot of block:') .' '. t('Text links') .'." class="float_right" />'. t('Images are showed with !abbr_css.', array('!abbr_css' => $abbr_css)) .' <span class="ok">'. t('Ideal for Web Accessibility.') .'</span></dd>'."\n";
      $output .= '  <dt id="ps_images">'. t('Image links') .'.</dt>'."\n";
      $output .= '  <dd><img src="'. $path_pagestyle .'/images/pagestyle_img.png" alt="'. t('Screenshot of block:') .' '. t('Image links') .'." class=""/><br />'. t('No Link text, only images in the !abbr_xhtml source code with standard 0 pixel margin.', array('!abbr_xhtml' =>  $abbr_xhtml)) .' <span class="warning">'. t('Warning: Not for: !abbr_wcag/!abbr_bitv 3.1! If JavaScript is not activated: No image change action if the cursor move over the images!', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span></dd>'."\n";
      $output .= '  <dt id="ps_select">'. t('Select menu') .'.</dt>'."\n";
      $output .= '  <dd><img src="'. $path_pagestyle .'/images/pagestyle_select.png" alt="'. t('Screenshot of block:') .' '. t('Select menu') .'." class="float_right"/></dd>'."\n";
      $output .= '</dl>'."\n";
      $output .= '<h3>'. t('Style display settings') .'</h3>'."\n";
      $output .= '<p>'. t('Enable or disable the display of certain page styles.') .' <span class="info">'. t('Minimum 2 styles are required.') .'</span></p>'."\n";
      $output .= '<h3>'. t('Advanced settings') .'</h3>'."\n";
      $output .= '<p>'. t('Page Style Normal') .': '. t('The default normal page style is Standard.') .'</p>'."\n";
      $output .= '<h3>'. t('Theme settings') .'</h3>'."\n";
      $output .= '<p>'. t('List display') .': '. t('Set the display of the list.') .' '. t('Style') .': '. t('Normal') .'/'. t('Inline.') .'.</p>'."\n";
      $output .= '<p>'. t('Text display') .': '. t('By hide text in the links, it shows only the images.') .' '. t('Hide text in the links') .': <span class="warning">'. t('Warning: Not for links with images in the !abbr_xhtml source code.', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</span></p>'."\n";
      $output .= '<p>'. t('Current page style display') .': '. t('By hide current page style, it shows no text.') .'</p>'."\n";
      $output .= '<h4>'. t('Overriding themable output') .'</h4>'."\n";
      $output .= '<p>'. t('Copy the files pagestyle-text.tpl.php, pagestyle-image.tpl.php and pagestyle-form.tpl.php, pagestyle.css and the directory "images" in your theme and edit it.') .'</p>'."\n";
      $output .= '<p>'. t('You can also download edited templates from the developers website: !link_ps.', array('!link_ps' => $link_ps)) .'</p>'."\n";
      $output .= '<h5>'. t('Example:') .' "'. t('Image links, not in a list') .'"</h5>'."\n";
      $output .= '<p><img src="'. $path_pagestyle .'/images/pagestyle_img2.png" alt="'. t('Screenshot of block:') .' '. t('Image links, not in a list') .'." class="float_right"/>'. t('Change the following elements:') .'<br /><del>&#060;ul&#062;/&#060;/ul&#062;</del> '. t('to') .': <ins>&#060;p&#062;/&#060;/p&#062;</ins><br /> <del>&#060;li&#062;&#060;/li&#062;</del> '. t('to') .': <ins>&#060;span class="display_hidden"&#062;&#160;&#124;&#160;&#060;/span&#062;</ins>.<br /><span class="info">'. t('!abbr_wcag/!abbr_bitv 10.5: Adjacent hyperlinks have to be separated by printable characters surrounded by spaces.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span><br /><span class="warning">'. t('Warning: Not for: !abbr_wcag/!abbr_bitv 13.6! Links are not in a list.', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span></p>'."\n";
      $output .= '<hr/>'."\n";
      $output .= '<h3>'. t('Source') .'</h3>'."\n";
      $output .= '<p>'. t('The !abbr_png and !abbr_gif images are in the directory "/pagestyle/images/" and the source file in "/pagestyle/images/source/".', array('!abbr_png' =>  $abbr_png, '!abbr_gif' =>  $abbr_gif)) .'</p>'."\n";
      $output .= '<p>[1] '. t('No images in the code (!abbr_css generated), only one link text (for example "Increase").', array('!abbr_css' => $abbr_css)) .'</p>'."\n";
      $output .= '<p>[2] '. t('!abbr_png images for new browsers and !abbr_gif images for old browsers (Internet Explorer 6).', array('!abbr_png' =>  $abbr_png, '!abbr_gif' =>  $abbr_gif)) .'</p>'."\n";
      return $output;
    break;
  }
}

/**
 * Builds and returns the pagestyle settings form.
 *
 * @ingroup forms
 * @see pagestyle_validate_form()
 */
function pagestyle_admin_settings() {
  $options = pagestyle_block_form_options();
  $abbr_xhtml = '<abbr lang="en" xml:lang="en" title="Extensible Hypertext Markup Language">XHTML</abbr>';
  $abbr_css = '<abbr lang="en" xml:lang="en" title="Cascading Style Sheets">CSS</abbr>';
  $abbr_wcag = '<abbr lang="en xml:lang="en" title="Web Content Accessibility Guidelines">WCAG</abbr>';
  $abbr_bitv = '<abbr lang="de" xml:lang="de" title="Barrierefreie Informationstechnik-Verordnung">BITV</abbr>';
  $form['pagestyle'] = array(
    '#type' => 'fieldset',
    '#title' => t('Global settings'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  $form['pagestyle']['pagestyle_block_type'] = array(
    '#type' => 'radios',
    '#title' => t('Block type'),
    '#options' => array(
      'text' => t('Text links') .' [1]',
      'image' => t('Image links') .' [2]',
      'select' => t('Select menu'),
    ),
    '#default_value' => variable_get('pagestyle_block_type', 'text'),
    '#description' => t('Select the type of block.') .'&#160;<br />[1] '. t('Images are showed with !abbr_css.', array('!abbr_css' =>  $abbr_css)) .' <span class="ok">'. t('Ideal for Web Accessibility.') .'</span><br />[2] '. t('Images in the !abbr_xhtml source code.', array('!abbr_xhtml' =>  $abbr_xhtml)) .' <span class="warning">'. t('Warning: Not for: !abbr_wcag/!abbr_bitv 3.1! No hover action if JavaScript is not activated!', array('!abbr_wcag' =>  $abbr_wcag, '!abbr_bitv' =>  $abbr_bitv)) .'</span>',
  );
  $form['pagestyle_link'] = array(
    '#type' => 'fieldset',
    '#title' => t('Style display settings'),
    '#description' => t('Enable or disable the display of certain page styles.') .' <span class="info">'. t('Minimum 2 styles are required.') .'</span>',
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
  $form['pagestyle_link']['pagestyle_black_white'] = array(
    '#type' => 'checkbox',
    '#title' => t('Black') .'/'. t('White'),
    '#default_value' => variable_get('pagestyle_black_white', 1),
  );
  $form['pagestyle_link']['pagestyle_white_black'] = array(
    '#type' => 'checkbox',
    '#title' => t('White') .'/'. t('Black'),
    '#default_value' => variable_get('pagestyle_white_black', 1),
  );
  $form['pagestyle_link']['pagestyle_yellow_blue'] = array(
    '#type' => 'checkbox',
    '#title' => t('Yellow') .'/'. t('Blue'),
    '#default_value' => variable_get('pagestyle_yellow_blue', 1),
  );
  $form['pagestyle_link']['pagestyle_standard'] = array(
    '#type' => 'checkbox',
    '#title' => t('Standard'),
    '#default_value' => variable_get('pagestyle_standard', 1),
  );
  $form['pagestyle_adv'] = array(
    '#type' => 'fieldset',
    '#title' => t('Advanced settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['pagestyle_adv']['pagestyle_normal'] = array(
    '#type' => 'select',
    '#title' => t('Page Style Normal'),
    '#options' => array(
      'black_white' => t('Black') .'/'. t('White'),
      'white_black' => t('White') .'/'. t('Black'),
      'yellow_blue' => t('Yellow') .'/'. t('Blue'),
      'standard' => t('Standard')
    ),
    '#default_value' => variable_get('pagestyle_normal', 'standard'),
    '#description' => t("The default normal page style is Standard."),
    '#attributes' => array('class' => 'pagestyle_admin'),
  );
  $form['pagestyle_theme'] = array(
    '#type' => 'fieldset',
    '#title' => t('Theme settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
  );
  $form['pagestyle_theme']['pagestyle_list_inline'] = array(
    '#type' => 'radios',
    '#title' => t('List display'),
    '#options' => array(
      'list' => t('Normal'),
      'inline' => t('Inline'),
    ),
    '#default_value' => variable_get('pagestyle_list_inline', 'list'),
    '#description' => t('Set the display of the list.'),
  );
  $form['pagestyle_theme']['pagestyle_display_links'] = array(
    '#type' => 'radios',
    '#title' => t('Text display'),
    '#options' => array(
      'display' => t('Show text in the links'),
      'display_hidden' => t('Hide text in the links') .' [5]',
    ),
    '#default_value' => variable_get('pagestyle_display_links', 'display'), // default to show text links.
    '#description' => t('By hide text in the links, it shows only the images.') .' <br/> <span class="warning">[5] '. t('Warning: Not for links with images in the !abbr_xhtml source code.', array('!abbr_xhtml' =>  $abbr_xhtml)) .'</span>',
  );
  $form['pagestyle_theme']['pagestyle_display_current_pagestyle'] = array(
    '#type' => 'radios',
    '#title' => t('Current page style display'),
    '#options' => array(
      'display' => t('Show current page style'),
      'display_hidden' => t('Hide current page style'),
    ),
    '#default_value' => variable_get('pagestyle_display_current_pagestyle', 'display'), // default to show current page style
    '#description' => t('By hide current page style, it shows no text.'),
  );
  return system_settings_form($form);
}

/**
 * Validate the pagestyle settings form.
 *
 * @see pagestyle_admin_settings()
 */
function pagestyle_admin_settings_validate($form, &$form_state) {
  $bw = $form_state['values']['pagestyle_black_white'];
  $wb = $form_state['values']['pagestyle_white_black'];
  $yb = $form_state['values']['pagestyle_yellow_blue'];
  $st = $form_state['values']['pagestyle_standard'];
  $normal = $form_state['values']['pagestyle_normal'];
  $normal_text = array(
    'black_white' => t('Black') .'/'. t('White'),
    'white_black' => t('White') .'/'. t('Black'),
    'yellow_blue' => t('Yellow') .'/'. t('Blue'),
    'standard' => t('Standard'),
  );
  if (($bw + $wb + $yb + $st) < 2) {
    form_set_error('pagestyle_standard', t('Minimum 2 styles are required.'));
  }
  if ($form_state['values']['pagestyle_'. $normal] != 1) {
    form_set_error('pagestyle_normal', t('The style %style is not available in "Style display settings".', array('%style' => $normal_text[$normal])));
  }
}