<?php
// $Id: pagestyle-image.tpl.php,v 1.1.2.3 2009/09/26 14:10:28 christianzwahlen Exp $

/**
 * @file
 * Image theme implementation for rendering a block.
 *
 * Available variables:
 * - $dest: The drupal function drupal_get_destination().
 * - $list_inline: Display the ul list "inline" or not.
 * - $display_links: Show or hide ("display_hidden") the text in the links.
 * - $black_white: The pagestyle Black/White "black_white".
 * - $white_black: The pagestyle Black/White "white_black".
 * - $yellow_blue: The pagestyle Black/White "yellow_blue".
 * - $standard: The pagestyle Standard "standard".
 * - $normal: The default normal page style is Standard "standard".
 * - $display_current_pagestyle: Show or hide ("display_hidden") the text of the current pagestyle.
 * - $pagestyle: The current page style (default Standard).
 *
 * @see template_preprocess_pagestyle_image()
 */
?>
<ul class="pagestyle_<?php print $list_inline; ?>">
  <?php  if ($black_white): ?>
  <li class="ps_black_white"><?php print l('<img src="'. base_path() . drupal_get_path("module", "pagestyle") .'/images/black_white_16.gif" alt="'. t('Black') .'/'. t('White') .'" class="rollover" />', 'pagestyle/black_white', array('attributes' => array('title' => t('Page Style') .': '. t('Black') .'/'. t('White'), 'class' => 'ps_black_white'), 'query' => $dest, 'html' => TRUE)); ?></li>
  <?php endif; ?>
  <?php  if ($white_black): ?>
  <li class="ps_white_black"><?php print l('<img src="'. base_path() . drupal_get_path("module", "pagestyle") .'/images/white_black_16.gif" alt="'. t('White') .'/'. t('Black') .'" class="rollover" />', 'pagestyle/white_black', array('attributes' => array('title' => t('Page Style') .': '. t('White') .'/'. t('Black'), 'class' => 'ps_white_black' ), 'query' => $dest, 'html' => TRUE)); ?></li>
  <?php endif; ?>
  <?php  if ($yellow_blue): ?>
  <li class="ps_yellow_blue"><?php print l('<img src="'. base_path() . drupal_get_path("module", "pagestyle") .'/images/yellow_blue_16.gif" alt="'. t('Yellow') .'/'. t('Blue') .'" class="rollover" />', 'pagestyle/yellow_blue', array('attributes' => array('title' => t('Page Style') .': '. t('Yellow') .'/'. t('Blue'), 'class' => 'ps_yellow_blue' ), 'query' => $dest, 'html' => TRUE)); ?></li>
  <?php endif; ?>
  <?php  if ($standard): ?>
  <li class="ps_standard"><?php print l('<img src="'. base_path() . drupal_get_path("module", "pagestyle") .'/images/standard_16.gif" alt="'. t('Standard') .'" class="rollover" />', 'pagestyle/standard', array('attributes' => array('title' => t('Page Style') .': '. t('Standard'), 'class' => 'ps_standard'), 'query' => $dest, 'html' => TRUE)); ?></li>
  <?php endif; ?>
</ul>
<p class="<?php print $display_current_pagestyle; ?>"><?php print t('Current Style'); ?>: <span id="pagestyle_current"><?php print $pagestyle; ?></span></p>